/*
 * SP00FiNG 0UTG0iNG PACKETS ViA LiNUX NETW0RK LAYER
 * -------------------------------------------------
 *
 * This is a linux kernel module to spoof from your box every udp/icmp outgoing
 * packet with destination = dstip
 *
 * If you wanna see output you have to sniff msg in <spoofip> machine
 * or if it's in your network you have to put your network interface
 * in promisc mode
 *
 * Compile with: gcc -O6 -c spoof.c -I/usr/src/linux/include
 *
 * Usage: insmod spoof dstip=192.168.1.1 spoofip=192.168.1.3 [dev=eth0]
 *
 * Every udp/icmp packet with destination=192.168.1.1 will be spoofed with
 * source=192.168.1.3
 *
 * Use it only for phun ... not for illegal purposes
 *
 * Based on the artice "Building Into The Linux Network Layer" written by
 * kossak and lifeline (Phrack vol.9, issue 55, file 12 of 19)
 *
 * pIGpEN <pigpen@s0ftpj.org>
 *
 */

#define MODULE
#define __KERNEL__

#include <linux/config.h>
#include <linux/module.h>
#include <linux/version.h>

#include <linux/byteorder/generic.h>
#include <linux/netdevice.h>
#include <net/protocol.h>
#include <net/pkt_sched.h>
#include <linux/if_ether.h>
#include <linux/ip.h>
#include <linux/skbuff.h>

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/file.h>
#include <asm/uaccess.h>


char *dev,*dstip,*spoofip;

MODULE_PARM(dev,     "s");
MODULE_PARM(dstip,   "s");
MODULE_PARM(spoofip, "s");


struct packet_type s_proto;
struct device *d;

/* net/ipv4/utils.c */

__u32 in_aton(const char *str) {
        unsigned long l;
        unsigned int val;
        int i;

        l = 0;
        for (i = 0; i < 4; i++) {
                l <<= 8;
                if (*str != '\0') {
                        val = 0;
                        while (*str != '\0' && *str != '.') {
                                val *= 10;
                                val += *str - '0';
                                str++;
                        }
                        l |= val;
                        if (*str != '\0')
                                str++;
                }
        }
        return(htonl(l));
}


int otp_func(struct sk_buff *skb, struct device *dv, struct packet_type *pt) {

       //skb->h.raw = skb->nh.raw + skb->nh.iph->ihl*4;

       switch(skb->nh.iph->protocol)
       {
        case IPPROTO_ICMP: if(skb->nh.iph->daddr==in_aton(dstip))
			   	skb->nh.iph->saddr=in_aton(spoofip);
			   break;

        case IPPROTO_UDP:  if(skb->nh.iph->daddr==in_aton(dstip))
				skb->nh.iph->saddr=in_aton(spoofip);
                           break;

        default: 	   break;
      }

     return 1;
}


int init_module() {
 if(!dstip || !spoofip) {
  printk("Usage: insmod spoof dstip=x.x.x.x spoofip=x.x.x.x [dev=devname]\n\n");
  return -ENXIO;
  }

 if (dev) {
   d = dev_get(dev);
   if (!d) {
    printk("Did not find device %s!\n", dev);
    printk("Using all known devices...");
   }
   else {
    printk("Using device %s, ifindex: %i\n",
            dev, d->ifindex);
    s_proto.dev = d;
   }
 }
 else
   printk("Using all known devices(wildcarded)...\n");

   s_proto.type = htons(ETH_P_ALL);
   s_proto.func = otp_func;
   dev_add_pack(&s_proto);

   return(0);
}

void cleanup_module() {
    dev_remove_pack(&s_proto);
    printk("Module unloaded\n");
}
